-- RightShifter24_2
-- DataをnShift分右に、丸めを行いつつシフトする for FSUB
-- Dataは "MSB & N数の仮数部"、また、末尾にGbit２つとRbit１つをつける

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity RightShifter24_2 is

	port(Data    : in std_logic_vector(23 downto 0);
	     nShift  : in std_logic_vector(7 downto 0);
	     Shifted : out std_logic_vector(26 downto 0));

end RightShifter24_2;

architecture STRUCTURE of RightShifter24_2 is

signal NS : std_logic_vector(4 downto 0);
signal Large : std_logic;

signal InD1, InD2, InD3, InD4, InD5 , InD0 : std_logic_vector(31 downto 0);   

begin -- STRUCTURE
   -- 
   Shifted <= Data & "000"
                when nShift = "00000" else
              '0' & Data & "00"
                when nShift = "00001" else
              "00" & Data & '0'
                when nShift = "00010" else
              "000" & Data
                when nShift = "00011" else
              "0000" & Data(23 downto 1) --& (Data(1) or (Data(0)))
                when nShift = "00100" else
              "00000" & Data(23 downto 2) --& (Data(2) or Data(1) or (Data(0)))
                when nShift = "00101" else
              "000000" & Data(23 downto 3) --& (Data(3) or Data(2) or Data(1) or (Data(0)))
                when nShift = "00110" else
              "0000000" & Data(23 downto 4) --& (Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
                when nShift = "00111" else
              "00000000" & Data(23 downto 5) --& (Data(5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
                when nShift = "01000" else
              "000000000" & Data(23 downto 6) --& (Data(6) or Data(5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
                when nShift = "01001" else
              "0000000000" & Data(23 downto 7) --& (Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
                when nShift = "01010" else
              "00000000000" & Data(23 downto 8) --& (Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
                when nShift = "01011" else
              "000000000000" & Data(23 downto 9) --& (Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
                when nShift = "01100" else
              "0000000000000" & Data(23 downto 10) --& (Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
                when nShift = "01101" else
              "00000000000000" & Data(23 downto 11) --& (Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
                when nShift = "01110" else
              "000000000000000" & Data(23 downto 12) --& (Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
                when nShift = "01111" else
              "0000000000000000" & Data(23 downto 13) --& (Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
                when nShift = "10000" else
              "00000000000000000" & Data(23 downto 14) --& (Data(14) or Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
                when nShift = "10001" else
              "000000000000000000" & Data(23 downto 15) --& (Data(15) or Data(14) or Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
                when nShift = "10010" else
              "0000000000000000000" & Data(23 downto 16) --& (Data(16) or Data(15) or Data(14) or Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
                when nShift = "10011" else
              "00000000000000000000" & Data(23 downto 17) --& (Data(17) or Data(16) or Data(15) or Data(14) or Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
                when nShift = "10100" else
              "000000000000000000000" & Data(23 downto 18) --& (Data(18) or Data(17) or Data(16) or Data(15) or Data(14) or Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
                when nShift = "10101" else
              "0000000000000000000000" & Data(23 downto 19) --& (Data(19) or Data(18) or Data(17) or Data(16) or Data(15) or Data(14) or Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
                when nShift = "10110" else
              "00000000000000000000000" & Data(23 downto 20) --& (Data(20) or Data(19) or Data(18) or Data(17) or Data(16) or Data(15) or Data(14) or Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
                when nShift = "10111" else
              "000000000000000000000000" & Data(23 downto 21) --& (Data(21) or Data(20) or Data(19) or Data(18) or Data(17) or Data(16) or Data(15) or Data(14) or Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
                when nShift = "11000" else
              "0000000000000000000000000" & Data(23 downto 22) --& (Data(22) or Data(21) or Data(20) or Data(19) or Data(18) or Data(17) or Data(16) or Data(15) or Data(14) or Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
                when nShift = "11001" else
              "00000000000000000000000000" & Data(23) --(Data(23) or Data(22) or Data(21) or Data(20) or Data(19) or Data(18) or Data(17) or Data(16) or Data(15) or Data(14) or Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)));
                when nShift = "11010" else
              "000000000000000000000000000";
    
    
--       InD0 <= "00000000000000000000000000000000" when nShift(7 downto 5) /= 0 else
--               Data & "00000000";  
--       InD1 <= InD0(31 downto 0) when nShift(4) = '0' else
--               "0000000000000000" & InD0(31 downto 16);
--       InD2 <= InD1(31 downto 0) when nShift(3) = '0' else
--               "00000000" & InD1(31 downto 8);
--       InD3 <= InD2(31 downto 0) when nShift(2) = '0' else
--               "0000" & InD2(31 downto 4);
--       InD4 <= InD3(31 downto 0) when nShift(1) = '0' else
--               "00" & InD3(31 downto 2);
--       InD5 <= InD4(31 downto 0) when nShift(0) = '0' else
--               "0" & InD4(31 downto 1);
--       Shifted <= InD5(31 downto 5);  
    
    
--   NS <= nShift(4 downto 0);
--   Large <= '1' when nShift(7 downto 5) /= "000" else '0'; 
--   Shifted <= "000000000000000000000000000"
--                when Large = '1' else
--              Data & "000"
--                when NS = "00000" else
--              '0' & Data & "00"
--                when NS = "00001" else
--              "00" & Data & '0'
--                when NS = "00010" else
--              "000" & Data
--                when NS = "00011" else
--              "0000" & Data(23 downto 1) --& (Data(1) or (Data(0)))
--                when NS = "00100" else
--              "00000" & Data(23 downto 2) --& (Data(2) or Data(1) or (Data(0)))
--                when NS = "00101" else
--              "000000" & Data(23 downto 3) --& (Data(3) or Data(2) or Data(1) or (Data(0)))
--                when NS = "00110" else
--              "0000000" & Data(23 downto 4) --& (Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when NS = "00111" else
--              "00000000" & Data(23 downto 5) --& (Data(5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when NS = "01000" else
--              "000000000" & Data(23 downto 6) --& (Data(6) or Data(5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when NS = "01001" else
--              "0000000000" & Data(23 downto 7) --& (Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when NS = "01010" else
--              "00000000000" & Data(23 downto 8) --& (Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when NS = "01011" else
--              "000000000000" & Data(23 downto 9) --& (Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when NS = "01100" else
--              "0000000000000" & Data(23 downto 10) --& (Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when NS = "01101" else
--              "00000000000000" & Data(23 downto 11) --& (Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when NS = "01110" else
--              "000000000000000" & Data(23 downto 12) --& (Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when NS = "01111" else
--              "0000000000000000" & Data(23 downto 13) --& (Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when NS = "10000" else
--              "00000000000000000" & Data(23 downto 14) --& (Data(14) or Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when NS = "10001" else
--              "000000000000000000" & Data(23 downto 15) --& (Data(15) or Data(14) or Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when NS = "10010" else
--              "0000000000000000000" & Data(23 downto 16) --& (Data(16) or Data(15) or Data(14) or Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when NS = "10011" else
--              "00000000000000000000" & Data(23 downto 17) --& (Data(17) or Data(16) or Data(15) or Data(14) or Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when NS = "10100" else
--              "000000000000000000000" & Data(23 downto 18) --& (Data(18) or Data(17) or Data(16) or Data(15) or Data(14) or Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when NS = "10101" else
--              "0000000000000000000000" & Data(23 downto 19) --& (Data(19) or Data(18) or Data(17) or Data(16) or Data(15) or Data(14) or Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when NS = "10110" else
--              "00000000000000000000000" & Data(23 downto 20) --& (Data(20) or Data(19) or Data(18) or Data(17) or Data(16) or Data(15) or Data(14) or Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when NS = "10111" else
--              "000000000000000000000000" & Data(23 downto 21) --& (Data(21) or Data(20) or Data(19) or Data(18) or Data(17) or Data(16) or Data(15) or Data(14) or Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when NS = "11000" else
--              "0000000000000000000000000" & Data(23 downto 22) --& (Data(22) or Data(21) or Data(20) or Data(19) or Data(18) or Data(17) or Data(16) or Data(15) or Data(14) or Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)))
--                when NS = "11001" else
--              "00000000000000000000000000" & Data(23) --(Data(23) or Data(22) or Data(21) or Data(20) or Data(19) or Data(18) or Data(17) or Data(16) or Data(15) or Data(14) or Data(13) or Data(12) or Data(11) or Data(10) or Data(9) or Data(8) or Data(7) or Data(6) or Data (5) or Data(4) or Data(3) or Data(2) or Data(1) or (Data(0)));
--                when NS = "11010" else
--              "000000000000000000000000000";
end STRUCTURE;
