-- F_ADSB_2
-- ソースオペランドの符号を判定して
-- FADD_SもしくはFSUB_Sに渡す

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity F_ADSB_2 is

	port(MANT_buf2      : in std_logic_vector(26 downto 0);
        Neq            : in std_logic;
        W_exp          : in std_logic_vector(7 downto 0);
        FUNC2          : in std_logic;
        SRC1_1,SRC2_1  : in std_logic_vector(31 downto 0);
	     OUTPUT         : out std_logic_vector(31 downto 0));

end F_ADSB_2;

architecture STRUCTURE of F_ADSB_2 is
   signal S : std_logic;
   signal FADD_S_OUT : std_logic_vector(30 downto 0);
   signal FSUB_S_OUT : std_logic_vector(30 downto 0);
   --signal SRC3 : std_logic_vector(31 downto 0);
   --signal SRC4 : std_logic_vector(31 downto 0);
   signal FUNCisADD : std_logic;        -- '1' when FUNC is ADD, '0' when FUNC is SUB
   signal USEDisADD : std_logic;        -- '1' when OUTPUT of ADD_s is used for myOUTPUT
   signal SRC2isBIG : std_logic;        -- '1' when ABS(SRC2) > ABS(SRC1)
   signal Equal : std_logic;            -- '1' when ABS(SRC1) = ABS(SRC2)
   --signal ZeroSub : std_logic;
   signal ZeroAdd : std_logic;
   signal SRC1isZero : std_logic;
   signal SRC2isZero : std_logic;



   component FADD_S
       port(SRC1,SRC2 : in std_logic_vector(31 downto 0);
            OUTPUT    : out std_logic_vector(30 downto 0);
            ZeroOut   : out std_logic);
   end component;
   component FSUB_S_2
	port(MANT_buf2 : in std_logic_vector(26 downto 0);
        Neq       : in std_logic;
        W_exp     : in std_logic_vector(7 downto 0);
	     OUTPUT    : out std_logic_vector(30 downto 0));
   end component;

begin -- STRUCTURER

   S <= SRC1_1(31) when USEDisADD = '1' else SRC1_1(31) xor SRC2isBIG;
   SRC1isZero <= '1' when SRC1_1(30 downto 23) = 0 else '0';
   SRC2isZero <= '1' when SRC2_1(30 downto 23) = 0 else '0';
             
   FUNCisADD <= '1' when FUNC2 = '0' else '0';
   USEDisADD <= FUNCisADD xor (SRC1_1(31) xor SRC2_1(31));
   SRC2isBIG <= '1' when SRC2_1(30 downto 0) > SRC1_1(30 downto 0) else '0';
   Equal <= '1' when (SRC1_1(30 downto 0) = SRC2_1(30 downto 0)) else '0';   

   FADD_S1   : FADD_S port map (SRC1_1,SRC2_1,FADD_S_OUT,ZeroAdd);
   FSUB_S_2_1: FSUB_S_2 port map (MANT_buf2,Neq,W_exp,FSUB_S_OUT);



   OUTPUT <= (others => '0' )--"00000000000000000000000000000000" -- Zero
                when SRC1isZero = '1' and SRC2isZero = '1'
                     else
             SRC1_1 when SRC2isZero = '1' else
             SRC2_1 when SRC1isZero = '1' and FUNCisADD = '1' else
             (others => '0')--"00000000000000000000000000000000" -- Zero
                when (USEDisADD and ZeroAdd) = '1' or 
                     --(USEDisADD = '0' and (ZeroSub = '1' or Equal = '1'))
                     (USEDisADD = '0' and Equal = '1')
                     else
             (not SRC2_1(31)) & SRC2_1(30 downto 0) when SRC1isZero = '1' else
             S & FADD_S_OUT when USEDisADD = '1' else
             S & FSUB_S_OUT;          

                        
end STRUCTURE;
