-- FINVSQRTの繰り返し計算部分
-- X(n+1) = (3 - A*X(n)*X(n))*X(n)/2を行う
-- 

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity FINVSQRT_repeat_3 is

	port(EXPin          : in std_logic_vector(7 downto 0);
        Zeroin         : in std_logic;
	     Xhin           : in std_logic_vector(12 downto 0);
        Xlin           : in std_logic_vector(11 downto 0);
        Ain            : in std_logic_vector(22 downto 0);
	     ThreeMinusAXX  : in std_logic_vector(27 downto 0);
        EXPout         : out std_logic_vector(7 downto 0);
        Zeroout        : out std_logic;
        Aout           : out std_logic_vector(22 downto 0);
        nextX          : out std_logic_vector(24 downto 0));

end FINVSQRT_repeat_3;

architecture STRUCTURE of FINVSQRT_repeat_3 is

--signal AXX : std_logic_vector(54 downto 0);        -- A*X(n)*X(n)
--signal AXX_buf : std_logic_vector(54 downto 0);
signal nextX_buf : std_logic_vector(52 downto 0);
signal nextXhh : std_logic_vector(26 downto 0);
signal nextXhl : std_logic_vector(26 downto 0);
signal nextXlh : std_logic_vector(25 downto 0);
signal nextXll : std_logic_vector(25 downto 0);

begin -- STRUCTURE



nextXhh <= ThreeMinusAXX(27 downto 14) * Xhin;
nextXhl <= ThreeMinusAXX(13 downto  0) * Xhin;
nextXlh <= ThreeMinusAXX(27 downto 14) * Xlin;
nextXll <= ThreeMinusAXX(13 downto  0) * Xlin;
nextX_buf <= (nextXhh & nextXll) + (("00000000000000" & nextXhl & "000000000000") + ("0000000000000" & nextXlh & "00000000000000"));

nextX <= nextX_buf(52 downto 28) when nextX_buf(52) = '1' else
         nextX_buf(51 downto 27);
--Xhout <= Xhin;
--Xlout <= Xlin;
EXPout <= EXPin;
Zeroout <= Zeroin;
Aout <= Ain;

end STRUCTURE;
