-- FINVSQRTの繰り返し計算部分
-- X(n+1) = (3 - A*X(n)*X(n))*X(n)/2を行う
-- 

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity FINVSQRT_repeat_6 is

	port(EXP            : in std_logic_vector(7 downto 0);
             Zero           : in std_logic;
	     Xhin           : in std_logic_vector(12 downto 0);
             Xlin           : in std_logic_vector(11 downto 0);
	     ThreeMinusAXX  : in std_logic_vector(27 downto 0);
             OUTPUT         : out std_logic_vector(31 downto 0));

end FINVSQRT_repeat_6;

architecture STRUCTURE of FINVSQRT_repeat_6 is

--signal AXX       : std_logic_vector(54 downto 0);        -- A*X(n)*X(n)
--signal AXX_buf   : std_logic_vector(54 downto 0);
signal nextX_buf : std_logic_vector(52 downto 0);
signal nextXhh   : std_logic_vector(26 downto 0);
signal nextXhl   : std_logic_vector(26 downto 0);
signal nextXlh   : std_logic_vector(25 downto 0);
signal nextXll   : std_logic_vector(25 downto 0);
signal nextX     : std_logic_vector(24 downto 0);
signal MANT      : std_logic_vector(22 downto 0);

begin -- STRUCTURE



   nextXhh <= ThreeMinusAXX(27 downto 14) * Xhin;
   nextXhl <= ThreeMinusAXX(13 downto  0) * Xhin;
   nextXlh <= ThreeMinusAXX(27 downto 14) * Xlin;
   nextXll <= ThreeMinusAXX(13 downto  0) * Xlin;
   nextX_buf <= (nextXhh & nextXll) + (("00000000000000" & nextXhl & "000000000000") + ("0000000000000" & nextXlh & "00000000000000"));

   nextX <= nextX_buf(52 downto 28) when nextX_buf(52) = '1' else
         nextX_buf(51 downto 27);

   MANT <= (others => '0') when (Zero = '1') else
           nextX(23 downto 1)+nextX(0);
   
   OUTPUT <= '0' & EXP & MANT;


end STRUCTURE;
