-- FLESS
-- SRC1 < SRC2 で -1
-- SRC1 >= SRC2 で 0

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity FLESS is

	port(SRC1,SRC2 : in std_logic_vector(31 downto 0);
	     OUTPUT    : out std_logic_vector(31 downto 0));

end FLESS;

architecture STRUCTURE of FLESS is

signal SRC1_2 : std_logic_vector(31 downto 0);
signal SRC2_2 : std_logic_vector(31 downto 0);



signal SRC1isZero : std_logic;
signal SRC2isZero : std_logic;


begin -- STRUCTURE 

    SRC1_2 <= (others => '0') when SRC1(30 downto 23) = 0 else
              SRC1;
    SRC2_2 <= (others => '0') when SRC2(30 downto 23) = 0 else
              SRC2; 
    
--    SRC1_2 <= SRC1(31 downto 23) & "00000000000000000000000" when SRC1(30 downto 23) = 0 else
--              SRC1;
--    SRC2_2 <= SRC2(31 downto 23) & "00000000000000000000000" when SRC2(30 downto 23) = 0 else
--              SRC2; 
    OUTPUT <= "11111111111111111111111111111111"  -- when both of SRC are Normal
       when ((SRC1_2(31) = '1' and SRC2_2(31) = '0') or 
             ((SRC1_2(31) = '0' and SRC2_2(31) = '0') and (SRC1_2(30 downto 0) < SRC2_2(30 downto 0))) or
             ((SRC1_2(31) = '1' and SRC2_2(31) = '1') and (SRC1_2(30 downto 0) > SRC2_2(30 downto 0))))
       else "00000000000000000000000000000000";
                        
end STRUCTURE;

