-- LeftShifter31
-- DataをnShift分左にシフトしたものをShiftedに出力

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity LeftShifter31_sub is

	port(Data    : in std_logic_vector(31 downto 0);
	     nShift  : in std_logic_vector(4 downto 0);
	     Shifted : out std_logic_vector(23 downto 0));

end LeftShifter31_sub;

architecture STRUCTURE of LeftShifter31_sub is
   signal InD1, InD2, InD3, InD4, InD5 : std_logic_vector(31 downto 0);
begin -- STRUCTURE

       InD1 <= Data(31 downto 0) when nShift(4) = '1' else
               Data(15 downto 0) & "0000000000000000";
       InD2 <= InD1(31 downto 0) when nShift(3) = '1' else
               InD1(23 downto 0) & "00000000";
       InD3 <= InD2(31 downto 0) when nShift(2) = '1' else
               InD2(27 downto 0) & "0000";
       InD4 <= InD3(31 downto 0) when nShift(1) = '1' else
               InD3(29 downto 0) & "00";
       InD5 <= InD4(31 downto 0) when nShift(0) = '1' else
               InD4(30 downto 0) & "0";
       Shifted <= InD5(30 downto 7);
        
    
    
--   Shifted <= "00000000000000000000000"                    when nShift = "00000" else
--              Data(0)           & "0000000000000000000000" when nShift = "00001" else
--              Data(1  downto 0) & "000000000000000000000"  when nShift = "00010" else
--              Data(2  downto 0) & "00000000000000000000"   when nShift = "00011" else
--              Data(3  downto 0) & "0000000000000000000"    when nShift = "00100" else
--              Data(4  downto 0) & "000000000000000000"     when nShift = "00101" else
--              Data(5  downto 0) & "00000000000000000"      when nShift = "00110" else
--              Data(6  downto 0) & "0000000000000000"       when nShift = "00111" else
--              Data(7  downto 0) & "000000000000000"        when nShift = "01000" else
--              Data(8  downto 0) & "00000000000000"         when nShift = "01001" else
--              Data(9  downto 0) & "0000000000000"          when nShift = "01010" else
--              Data(10 downto 0) & "000000000000"           when nShift = "01011" else
--              Data(11 downto 0) & "00000000000"            when nShift = "01100" else
--              Data(12 downto 0) & "0000000000"             when nShift = "01101" else
--              Data(13 downto 0) & "000000000"              when nShift = "01110" else
--              Data(14 downto 0) & "00000000"               when nShift = "01111" else
--              Data(15 downto 0) & "0000000"                when nShift = "10000" else
--              Data(16 downto 0) & "000000"                 when nShift = "10001" else
--              Data(17 downto 0) & "00000"                  when nShift = "10010" else
--              Data(18 downto 0) & "0000"                   when nShift = "10011" else
--              Data(19 downto 0) & "000"                    when nShift = "10100" else
--              Data(20 downto 0) & "00"                     when nShift = "10101" else
--              Data(21 downto 0) & '0'                      when nShift = "10110" else
--              Data(22 downto 0)                            when nShift = "10111" else
--              Data(23 downto 1)                            when nShift = "11000" else
--              Data(24 downto 2)                            when nShift = "11001" else
--              Data(25 downto 3)                            when nShift = "11010" else
--              Data(26 downto 4)                            when nShift = "11011" else
--              Data(27 downto 5)                            when nShift = "11100" else
--              Data(28 downto 6)                            when nShift = "11101" else
--              Data(29 downto 7);--                            when nShift = "11110" else
--              --Data(30 downto 8);--nShift cannot be "11111"
end STRUCTURE;
